IPFRMBU EQU P2    ;I/P FROM BALLOT UNIT(I/P CONFIGURED)

;HEXPAD PORT DEFINITIONS
RW1 EQU P2.4    ;row1 declared for keypad 
RW2 EQU P2.5    ;row2 declared for keypad
RW3 EQU P2.6    ;row3 declared for keypad
RW4 EQU P2.7    ;row4 declared for keypad
CL1 EQU P3.4    ;column1 declared for keypad
CL2 EQU P3.5    ;column2 declared for keypad
CL3 EQU P3.6   ;column3 declared for keypad
CL4 EQU P3.7   ;column4 declared for keypad

;LCD PORT DEFINITIONS
DATAPORT EQU P0
EN EQU P1.2
RW EQU P1.1
RS EQU P1.0
DE EQU 0FFH				   ;(WHERE IS IT USED???)
D7 EQU P0.7

RDYSGN EQU P1.4  ;THIS PIN SENDS SIGNAL TO BU TO GLOW MACHINE READY LED(O/P CONFIGURED)

VOTSNL EQU P1.5  ;THIS PIN SENDS SIGNAL TO BU TO GLOW VOTE CASTED LED(O/P CONFIGURED)

STATLD EQU P3.1  ;THIS PIN IS SET TO GLOW STATUS LED(O/P CONFIGURED)

MCONBTN EQU P3.0  ;THIS PIN IS SET OR CLEARED ACCORDING TO MANUAL CONTROL BUTTON PRESSED OR NOT(I/P CONFIGURED)

RESBUT EQU P1.3   ;THIS PIN BECOMES LOW WHEN RESULT BUTTON IS PRESSED

DIG5 EQU 70h
DIG4 EQU 71h
DIG3 EQU 72h 
DIG2 EQU 73h
DIG1 EQU 74h

TOTALLB EQU 76h
TOTALHB EQU 77h

MEM EQU 45h				;TO BRING EACH CHAR OF ENTERED PASSWORD ONE BY ONE
STATUS EQU 47h	  		;TO ENSURE POLL-RESULT-POLL SEQUENCE
COUNT EQU 49h
MODE EQU 60h            ;SAVES D SELECTED MODE'S HEX VALUE
CCODE EQU 79h			;TO SAVE CANDIDATE'S CODE OBTINED FRM BU

;EEPROM PORT DEFINITIONS ETC.
SDA1 EQU P1.6
SCL1 EQU P1.7


WTCMD EQU   10100000B       ;WRITE DATA COMMAND 
RDCMD EQU   10100001B       ;READ DATA COMMAND 

HBADD EQU 7Eh
MEMORY EQU 7Fh




ORG 0000h
LJMP MAIN

ORG 0003h
LJMP CLOSE
  
ORG 0013h
LJMP TOTAL



MAIN: 	  ;***************************MAIN*******************

SETB RESBUT
SETB STATLD


MOV DATAPORT,#0FFH       
       	       	ACALL LCD216 				    ;LCD INITIALISATION
        ACALL LCDCLR 
        ACALL RETHOME
        ACALL DONCOFF      			;LCD INITIALISED               

LCALL STATREAD
MOV A,STATUS
CJNE A,#00h,LABEL1 
JMP LABEL2 				  
LABEL1:LJMP RESULT			               
LABEL2:LCALL EVM_LCD1			  		;DISPLAYS "VOTING MODE"
LCALL DELAY_5SEC
LCALL PASSWORDDETECT








                                                                                                                             
INITIALIZEM:       ;INITIALIZING MEMORY LOCATIONS(USED FOR STORING TOTAL NO.OF VOTES OF EACH CANDIDATE) TO '0'
                   ;MEMORY LOCATIONS 32, 33 ARE FOR CANDIDATE1'S VOTE COUNT
                   ;AND 34,35 ARE FOR CANDIDATE2'S VOTE COUNT AND SO ON....
        MOV R0,#32h
        MOV R2,#10h
        LABEL3:
			    MOV @R0,#00h
			    INC R0
				DJNZ R2,LABEL3

MOV TOTALLB,#00h					 ;INITIALISING TOTAL VOTE COUNT TO ZERO
MOV TOTALHB,#00h

ACALL MEMORYINIT
ACALL MEMINIT

MOV IE,#85h							;ENABLING BOTH 'CLOSE' AND 'TOTAL' INTERRUPT

MACFREE:							 ;MACHINE IS FREE TO ACCEPT NEW CODE FRM BU AT DIS PT.
		;SETB VOTSNL					
		CLR STATLD                   ;TO GLOW SATUS LED FOR THE VERY FIRST TIME
		SETB RDYSGN   			     ;CONFIGURING AS O/P
		SETB MCONBTN      			 ;CONFIGURING AS I/P
		JB MCONBTN,$  
  		SETB STATLD    			 ;WAIT TILL MANUAL CONTROL BUTTON IS PRESSED
		CLR RDYSGN       			 ;WHEN PRESSED, SEND SIGNAL TO BU TO SWITCH 
									 ;ON ITS MACHINE READY LED

NOP
SETB RDYSGN



MOV IPFRMBU,#0FFh 			 ;CONFIGURING PORT 

;REFRESH:       						 ;CLEAR THE PORT (INTERFACED WITH BU) FROM
									 ;THE PREVIOUS CODE OBTAINED FRM BU

		
;        MOV A,IPFRMBU
 ;       ANL A,#00001111b
  ;      CJNE A,#00h,REFRESH


START:          					 ;POLLING PROGRAM TO DETECT THE CODE FROM BU

        ;MOV IPFRMBU,#0FFh 			 ;CONFIGURING PORT AS I/P
        MOV A,IPFRMBU
        ANL A,#00001111b
        CJNE A,#0Fh,START1
	JMP START  
                                
START1: MOV A,IPFRMBU
ANL A,#00001111b
CJNE A,#09h,VALID
CLR VOTSNL
NOP
SETB VOTSNL
JMP MACFREE

VALID:  ;*******INCREMENTING VOTE(INDIVIDUAL & TOTAL) AND WRITING IT TO EEPROM*******							

		MOV CCODE,A
		MOV R2,TOTALLB
		CJNE R2,#0FFh,LABEL11		   ;TOTAL VOTE COUNT SHUD B INCREMENTED AS
		INC TOTALHB						   ;SOON AS WE GET CONFIRMED DAT A VALID 
		MOV TOTALLB,#00h				   ;VOTE HAS BEEN CASTED
		JMP LABEL12

LABEL11:
		INC TOTALLB

LABEL12: 
		LCALL TOTALWRITE
		MOV R0,#30h 						;INITIALISING MEMORY LOCATION TO 30h
        MOV B,#02h 							;AS 2 BYTES ARE RESERVED TO STORE VOTE 
											;COUNT OF EACH CANDIDATE 
        MOV A,CCODE
		MUL AB
        ADD A,R0
        MOV R0,A
        MOV A,@R0
        CJNE A,#0FFh,INCRM
        INC R0
        MOV A,@R0
        INC A
        MOV @R0,A
        DEC R0
    MOV @R0,#00h
    JMP COMP

INCRM:
    INC A
    MOV @R0,A
        

COMP:
        CLR VOTSNL
		
	;ACALL DELAY_5SEC
 
NOP
SETB VOTSNL
LCALL VOTEWRITE
        LJMP MACFREE







RESULT:       ;*******************************RESULT ROUTINE *************************


LCALL EVM_LCD5		                			;DISPLAY "RESULT MODE" 
LCALL DELAY_5SEC    
LCALL PASSWORDDETECT
MOV IE,#84h						;ENABLING 'TOTAL' INTERRUPT ONLY, AND DISABLING 
								;'CLOSE' INTERRUPT
MOV COUNT,#00h
LCALL VOTEREAD
LCALL STATWRITE0
 
LABEL14:
	MOV R0,#32h
	MOV A,COUNT
	MOV B,#02h
	MUL AB
	ADD A,R0
	MOV R0,A
	MOV A,@R0
	MOV R2,A						;LOWER BYTE
	INC R0
	MOV A,@R0
	MOV R1,A    	  					;HIGHER BYTE
	ACALL CONVERSION 

;LCD MODULE
                                    
	ACALL LCDCLR 
    ACALL FCBFL 
    ACALL COMMAND 
    ACALL EVM_LCDO 
	ACALL DELAY_5SEC
	JB RESBUT,$
	INC COUNT
	MOV A,COUNT
	CJNE A,#08h,LABEL14
	MOV COUNT,#00h
	JMP LABEL14
             
;LCD ROUTINES


EVM_LCDO:
		
	MOV DPTR,#TABLE1O
	MOV A,COUNT
	CLR C
	MOV B,#0Ch
	MUL AB
	ADD A,DPL
	MOV DPL,A
	MOV A,#00h
	ADDC A,DPH
	MOV DPH,A
    ACALL WRITE1O
    ACALL FCBSL
    ACALL COMMAND
	MOV DPTR,#TABLE2O
    ACALL WRITE2O        
    RET

WRITE1O:
	CLR A
    MOVC A,@A+DPTR
    JZ BACK2O
	ACALL DISPLAY
    INC DPTR
    SJMP WRITE1O

BACK2O: RET
        
TABLE1O: 
    DB 'CANDIDATE 1',0
    DB 'CANDIDATE 2',0
    DB 'CANDIDATE 3',0
    DB 'CANDIDATE 4',0
    DB 'CANDIDATE 5',0
    DB 'CANDIDATE 6',0
    DB 'CANDIDATE 7',0
    DB 'CANDIDATE 8',0


WRITE2O:
	CLR A
	MOVC A,@A+DPTR
    JZ BACK3O
    ACALL DISPLAY
    INC DPTR
    SJMP WRITE2O
								 
BACK3O: 
	ACALL BACK3
	RET
		

                                                                                                                   
TABLE2O: DB 'VOTES: ',0 
  




;********************************** CLOSE ROUTINE *************************************
CLOSE :   
;INITIALIZING MEMORY LOCATIONS(USED FOR STORING TOTAL NO.OF VOTES OF EACH CANDIDATE) 
;TO '0' MEMORY LOCATIONS 32, 33 ARE FOR CANDIDATE1'S VOTE COUNT AND 34,35 ARE FOR
;CANDIDATE2'S VOTE COUNT AND SO ON....

SETB STATLD
LCALL STATWRITE1
MOV A,PCON
ORL A,#02h
MOV PCON,A
RETI





;*********************************TOTAL ROUTINE **********************************
TOTAL:
	LCALL TOTALREAD
	MOV R2,TOTALLB
	MOV R1,TOTALHB
	LCALL CONVERSION

;LCD MODULE
MOV DATAPORT,#0FFH       
       	       	ACALL LCD216 				    ;LCD INITIALISATION
        ACALL LCDCLR 
        ACALL RETHOME
        ACALL DONCOFF
	ACALL LCDCLR 
    ACALL FCBFL 
    ACALL COMMAND
	ACALL EVM_LCDT 
    RETI         



EVM_LCDT:
		
		MOV DPTR,#TABLE1T
		ACALL WRITE
       	ACALL FCBSL 
       	ACALL COMMAND
       	MOV DPTR,#TABLE2T
		ACALL WRITE2T        
       	RET


TABLE1T: 
        DB 'TOTAL NO. OF',0
  
WRITE2T:
		CLR A
		MOVC A,@A+DPTR
        JZ BACK3T		
        ACALL DISPLAY
        INC DPTR
        SJMP WRITE2T

BACK3T:
		ACALL BACK3	;BACK3 DISPLAYS D DECIMAL NUMBER SATORED AT DIG5,DIG4, ...DIG0
		RET
                                                                                                              
TABLE2T: DB 'VOTES: ',0 











;***************PASSWORD DETECTION**********************************


PASSWORDDETECT:

LCALL EVM_LCD2                   ;DISPLAYS "ENTER PASSWORD ......"

INITIALIZEP:      			 ;INITIALIZING MEMORY LOCATIONS(USED FOR STORING THE 
							 ;PASSWORD ACCEPTED FROM THE USER,ie, OFFICER IN CHARGE)
       MOV R0,#50h
       MOV R2,#06h
       LABEL4:
                MOV @R0,#00h
                INC R0
                DJNZ R2,LABEL4

MOV R0,#50h
MOV R2,#06h
KEYCALL: LCALL KEYDETECTION
MOV @R0,A
INC R0
CJNE R2,#06h,LCD1

;***LCD MODULE TO DISPLAY '*' WHENEVER A KEY IS PRESSED TO ENTER PASSWORD***
                                                            
        ;MOV DATAPORT,#0FFH       
        ;ACALL LCD216        		 ; LCD INITIALISATION
        ;ACALL LCDCLR 
        ;ACALL RETHOME
        ;ACALL DONCB       		; LCD INITIALISED    
		ACALL LCDCLR 
        ACALL FCBFL 
        ACALL COMMAND            
		          
LCD1:
		MOV DPTR,#TABLE1
        ACALL WRITE
        
TABLE1:  DB '*',0           

DEC R2
CJNE R2,#00h,KEYCALL




;**********COMPARING ALREADY STORE PASSWORD AND ENTERED PASSWORD*********


;CHECK STATUS VALUE HERE AGAIN, IF IT IS '1'(MEANS WE ARE WORKING IN RESULT MODE)
; THEN USE"MOV DPTR,#LIST1R" AND IF IT IS '0'(MEANS WE ARE WORKING IN VOTING MODE)
; THEN USE"MOV DPTR,#LIST1V"           
MOV R0,#50h
        	MOV R3,#06h
				
		MOV A,STATUS

		CJNE A,#00h,RESLT
		MOV DPTR,#LIST1V
		JMP COMMON
RESLT:	MOV DPTR,#LIST1R 					;LIST1 POINTS TO PASSWORD OF VOTING MODE
COMMON:
        

CHECKING: 
MOV MEM,@R0        
MOV A,#00h
        MOVC A,@A+DPTR
     	CJNE A,MEM,INCORRECT 
	INC R0             
        INC DPTR 
	DJNZ R3,CHECKING
	JMP CORRECT


INCORRECT:
		LCALL EVM_LCD3							;DISPLAYS "WRONG PASSWORD"
		ACALL DELAY_5SEC
		LJMP PASSWORDDETECT



CORRECT:
		LCALL EVM_LCD4           			    ;DISPLAY "PASSWORD ACCEPTED & PROCEED AHEAD"
		

RET			   						;TO RETURN FROM PASSWORD DETECTION

LIST1V: DB '0','1','2','3','4','5'	   ;PASSWORD OF VOTING MODE
LIST1R: DB '6','7','8','9','A','B'	   ;PASSWORD OF RESULT MODE									
		

		



;*********PASSWORD DETECTION ENDS HERE****************












;*************************HEX TO DECIMAL CONVERSION*******************************
CONVERSION:
MOV R3,#00D
MOV R4,#00D
MOV R5,#00D
MOV R6,#00D
MOV R7,#00D
 
MOV B,#10D
MOV A,R2
DIV AB
MOV R3,B                 
MOV B,#10             				;R7,R6,R5,R4,R3
DIV AB
MOV R4,B
MOV R5,A
CJNE R1,#0H,HIGH_BYTE   			;CHECK FOR HIGH BYTE
SJMP ENDD
 
HIGH_BYTE:
		MOV A,#6
        ADD A,R3
		MOV B,#10
		DIV AB
        MOV R3,B
		ADD A,#5
        ADD A,R4
		MOV B,#10
		DIV AB
        MOV R4,B
		ADD A,#2
        ADD A,R5
		MOV B,#10
		DIV AB
        MOV R5,B
        CJNE R6,#00D,ADD_IT
        SJMP CONTINUE

ADD_IT:
        ADD A,R6

CONTINUE:
        MOV R6,A
        DJNZ R1,HIGH_BYTE
        MOV B,#10D
        MOV A,R6
        DIV AB
        MOV R6,B
        MOV R7,A

ENDD:   
		MOV A,#30h
        ADD A,R7
        MOV DIG5,A
        MOV A,#30h
        ADD A,R6
        MOV DIG4,A
        MOV A,#30h
        ADD A,R5
        MOV DIG3,A
        MOV A,#30h
        ADD A,R4
        MOV DIG2,A
        MOV A,#30h
        ADD A,R3
        MOV DIG1,A
RET				  						;TO RETURN FROM HEX TO BCD CONVERSION


;***********HEX TO BCD CONVERSION ENDS HERE******************







;****************************** 5 SEC DELAY ROUTINE*************************

DELAY_5SEC:     

                MOV R1,#05h
                AGAIN2:MOV R2,#0FFh      
                AGAIN1:MOV R7,#0FFh
                DJNZ R7,$
                DJNZ R2,AGAIN1
                DJNZ R1, AGAIN2
                RET

;*********DELAY_5SEC ENDS HERE*****************








;*************************KEYDETECTION MODULE*************************
KEYDETECTION:
		CLR RW1							  ;configuring rows for o/p  
        CLR RW2
        CLR RW3
        CLR RW4	
		SETB CL1						  ;configuring columns for i/p	
        SETB CL2
        SETB CL3
        SETB CL4		  
RELEASE:        				  ;TO CHECK WHETHER THE KEY IS STILL PRESSED OR RELEASED
		CLR RW1
        CLR RW2
        CLR RW3
        CLR RW4
        JNB CL1, RELEASE
        JNB CL2, RELEASE
        JNB CL3, RELEASE
        JNB CL4, RELEASE
        AJMP STARTING

STARTING:  				          ;TO CHECK WHETHER A KEY IS PRESSED
		ACALL DELAY
        JNB CL1, DEBOUNCE
        JNB CL2, DEBOUNCE
        JNB CL3, DEBOUNCE
        JNB CL4, DEBOUNCE
        JMP STARTING
		
DEBOUNCE:       				  ;TO CHECK WHETHER KEY IS ACTUALLY PRESSED & IT IS NOT DEBOUNCE
		ACALL DELAY
        JNB CL1, OVER
        JNB CL2, OVER
        JNB CL3, OVER
        JNB CL4, OVER
        JMP STARTING
              
OVER:
		CLR RW1
        SETB RW2
        SETB RW3
        SETB RW4
        JNB CL1, ROW1
        JNB CL2, ROW1
        JNB CL3, ROW1
        JNB CL4, ROW1
        SETB RW1
        CLR RW2
        SETB RW3
        SETB RW4
        JNB CL1, ROW2
        JNB CL2, ROW2
        JNB CL3, ROW2
        JNB CL4, ROW2
        SETB RW1
        SETB RW2
        CLR RW3
        SETB RW4
        JNB CL1, ROW3
        JNB CL2, ROW3
        JNB CL3, ROW3
        JNB CL4, ROW3
        SETB RW1
        SETB RW2
        SETB RW3
        CLR RW4
        JNB CL1, ROW4
        JNB CL2, ROW4
        JNB CL3, ROW4
        JNB CL4, ROW4

ROW1:
		MOV DPTR, #KCODE1
        SJMP FIND

ROW2:
        MOV DPTR, #KCODE2
        SJMP FIND
ROW3:
        MOV DPTR, #KCODE3
        SJMP FIND
ROW4:
        MOV DPTR, #KCODE4
        SJMP FIND
                               
FIND:
		JB CL1, N1
        JMP MATCH

N1:
		INC DPTR
        JB CL2, N2
        JMP MATCH

N2:
		INC DPTR
        JB CL3, N3
        JMP MATCH

N3:
		INC DPTR
        JB CL4, STRT1
        JMP MATCH
        
STRT1:  LJMP STARTING

MATCH:
		CLR A
        MOVC A, @A+DPTR
RET		;TO RETURN FROM KEYDETECTION MODULE
	

                                
KCODE1: DB '0','1','2','3'

KCODE2: DB '4','5','6','7'

KCODE3: DB '8','9','A','B'

KCODE4: DB 'C','D','E','F'

									

DELAY:	
		MOV R4, #255
        NEXT:   MOV R5, #255
		AGAIN:  DJNZ R5, AGAIN
        DJNZ R4, NEXT
		RET  

;*****************KEYDETECTION MODULE ENDS HERE*****************								








;***********************LCD DISPLAY MODULES**********************



EVM_LCD1: 			;********************EVM_LCD1 STARTS HERE********						

;		MOV DATAPORT,#0FFH       
;		ACALL LCD216       						;LCD INITIALISATION
 ;      	ACALL LCDCLR 
 ;     	ACALL RETHOME
 ;     	ACALL DONCOFF      						;LCD INITIALISED               
      	ACALL LCDCLR 
        ACALL FCBFL 
        ACALL COMMAND 
        MOV DPTR,#TABLE11
        ACALL WRITE
        ACALL FCBSL 
        ACALL COMMAND
        MOV DPTR,#TABLE21
        ACALL WRITE       
		RET							;******TO RETURN FROM EVM_LCD1********* 


TABLE11:  DB 'VOTING MODE',0
TABLE21:  DB 'STARTING.....',0






EVM_LCD2: 			;********************EVM_LCD2 STARTS HERE********						

		;MOV DATAPORT,#0FFH       
		;ACALL LCD216       						;LCD INITIALISATION
;       	ACALL LCDCLR 
 ;     	ACALL RETHOME
  ;    	ACALL DONCOFF      						;LCD INITIALISED               
      	ACALL LCDCLR 
        ACALL FCBFL 
        ACALL COMMAND 
        MOV DPTR,#TABLE12
        ACALL WRITE
        ACALL FCBSL 
        ACALL COMMAND
        MOV DPTR,#TABLE22
        ACALL WRITE       
		RET								;******TO RETURN FROM EVM_LCD2********* 



TABLE12:  DB 'ENTER PASSWORD',0
TABLE22:  DB '6 CHARACTER LONG',0






EVM_LCD3: 			;********************EVM_LCD3 STARTS HERE********						

;		MOV DATAPORT,#0FFH       
;		ACALL LCD216       						;LCD INITIALISATION
 ;      	ACALL LCDCLR 
  ;    	ACALL RETHOME
   ;   	ACALL DONCOFF      						;LCD INITIALISED               
      	ACALL LCDCLR 
        ACALL FCBFL 
        ACALL COMMAND 
        MOV DPTR,#TABLE13
        ACALL WRITE
        ACALL FCBSL 
        ACALL COMMAND
        MOV DPTR,#TABLE23
        ACALL WRITE       
		RET								;******TO RETURN FROM EVM_LCD3********* 


TABLE13:  DB 'WRONG PASSWORD',0
TABLE23:  DB 'ENTERED....',0





EVM_LCD4: 			;********************EVM_LCD4 STARTS HERE********						

;		MOV DATAPORT,#0FFH       
;		ACALL LCD216       						;LCD INITIALISATION
 ;      	ACALL LCDCLR 
  ;    	ACALL RETHOME
   ;   	ACALL DONCOFF      						;LCD INITIALISED               
      	ACALL LCDCLR 
        ACALL FCBFL 
        ACALL COMMAND 
        MOV DPTR,#TABLE14
        ACALL WRITE
        ACALL FCBSL 
        ACALL COMMAND
        MOV DPTR,#TABLE24
        ACALL WRITE       
		RET							;******TO RETURN FROM EVM_LCD4********* 


TABLE14:  DB 'PASWORD ACCEPTED',0
TABLE24:  DB 'PROCEED AHEAD..',0





EVM_LCD5: 			;********************EVM_LCD5 STARTS HERE********						

;		MOV DATAPORT,#0FFH       
;		ACALL LCD216       						;LCD INITIALISATION
 ;      	ACALL LCDCLR 
  ;    	ACALL RETHOME
   ;   	ACALL DONCOFF      						;LCD INITIALISED               
  		ACALL LCDCLR 
        ACALL FCBFL 
        ACALL COMMAND 
        MOV DPTR,#TABLE15
        ACALL WRITE
        ACALL FCBSL 
        ACALL COMMAND
        MOV DPTR,#TABLE25
        ACALL WRITE       
		RET       					;******TO RETURN FROM EVM_LCD5********* 


TABLE15:  DB 'RESULT MODE',0
TABLE25:  DB 'STARTING...',0







;***********************LCD ROUTINES COMMON TO ALL*******************


;LCD ROUTINES

CHKBUSY: 										;Checks for the status of the LCD
        SETB D7
        CLR RS
        SETB RW

LOOP:   
	    CLR EN
        SETB EN 
        JB D7,LOOP  
		RET 

DISPLAY:
        ACALL CHKBUSY
        MOV DATAPORT,A
        SETB RS
        CLR RW
        SETB EN
        CLR EN        
		RET         

COMMAND:
        ACALL CHKBUSY
        MOV DATAPORT,A
        CLR RS
        CLR RW
        SETB EN
        CLR EN
		RET         

LCD216: 
		MOV A,#38H			;FORCES 2 X 16 MATRIX
        ACALL COMMAND
		RET       

LCDCLR:
		MOV A,#01H 
        ACALL COMMAND
		RET

RETHOME:
		MOV A,#02H					;RETURN HOME    
        ACALL COMMAND
		RET
  
DONCOFF:
		MOV A,#0CH 
       	ACALL COMMAND
		RET   

DONCB:
		MOV A,#0FH 
        ACALL COMMAND
		RET   

FCBFL:  
		MOV A,#80H 
        ACALL COMMAND
		RET   

FCBSL: 
		MOV A,#0C0H 
        ACALL COMMAND
		RET   

SCR:	;NO NEED OF THIS ROUTINE
		MOV A,#14H 
        ACALL COMMAND
		RET


WRITE:        
		CLR A
        MOVC A,@A+DPTR
        JZ BACK2
        ACALL DISPLAY
        INC DPTR
        JMP WRITE

BACK2:  RET

BACK3: 
		MOV A,DIG5
        ACALL DISPLAY
        MOV A,DIG4
        ACALL DISPLAY
        MOV A,DIG3
        ACALL DISPLAY
        MOV A,DIG2
        ACALL DISPLAY
        MOV A,DIG1
        ACALL DISPLAY
        RET


;*****************LCD ROUTINES COMMON TO ALL END HERE************************





   




;******************EEPROM READ AND WRITE ROUTINES***************************

;*******ROUTINE1: READING STATUS BYTE TO GO IN WHICH MODE********

STATREAD:

 MOV     A,#WTCMD        ;LOAD WRITE COMMAND TO SEND ADDRESS

               CALL    OUTS            ;SEND IT

              MOV     A,#00H            ;GET LOW BYTE ADDRESS

              CALL    OUT             ;SEND IT

              CALL    CREAD           ;GET DATA BYTE

              MOV A,R1  
MOV STATUS,A












;MOV DPTR,#000h
;ACALL EEPROM_READ
;MOV STATUS,A
RET




;************************ROUTINE 2: TO SET STATUS AS ZERO***********************
STATWRITE0:


MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT

               MOV A,#00H ;GET BYTE ADDRESS

               CALL OUT ;SEND IT

               MOV A,#00H ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION
ACALL DELAY_STOP










;MOV DPTR,#000h
;MOV B,#00h
;ACALL EEPROM_WRITE   
RET







;************************ROUTINE 3: TO SET STATUS AS ONE***********************
STATWRITE1:


MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT

               MOV A,#00H ;GET BYTE ADDRESS

               CALL OUT ;SEND IT

               MOV A,#01H ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION
ACALL DELAY_STOP








;MOV DPTR,#000h
;MOV B,#01h
;ACALL EEPROM_WRITE  
RET







;************************ROUTINE 4: TO WRITE TOTAL NUMBER OF VOTES***************
TOTALWRITE:


MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT

               MOV A,#84H ;GET BYTE ADDRESS

               CALL OUT ;SEND IT

               MOV A,TOTALLB ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION
ACALL DELAY_STOP





MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT

               MOV A,#85H ;GET BYTE ADDRESS

               CALL OUT ;SEND IT

               MOV A,TOTALHB ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION

ACALL DELAY_STOP







;MOV DPTR,#125H
;MOV R0,#TOTALLB
;MOV B,@R0
;ACALL EEPROM_WRITE  
;INC R0
;MOV B,@R0
;INC DPTR
;ACALL EEPROM_WRITE
RET








;***************************ROUTINE 5:TO READ TOTAL NUMBER OF VOTES **************
TOTALREAD:




MOV     A,#WTCMD        ;LOAD WRITE COMMAND TO SEND ADDRESS

               CALL    OUTS            ;SEND IT

              MOV     A,#84H            ;GET LOW BYTE ADDRESS

              CALL    OUT             ;SEND IT

              CALL    CREAD           ;GET DATA BYTE

              MOV A,R1  
MOV TOTALLB,A



MOV     A,#WTCMD        ;LOAD WRITE COMMAND TO SEND ADDRESS

               CALL    OUTS            ;SEND IT

              MOV     A,#85H            ;GET LOW BYTE ADDRESS

              CALL    OUT             ;SEND IT

              CALL    CREAD           ;GET DATA BYTE

              MOV A,R1
MOV TOTALHB,A  












;MOV DPTR,#125H
;ACALL EEPROM_READ
;MOV TOTALLB,A
;INC DPTR
;ACALL EEPROM_READ
;MOV TOTALHB,A           
RET





;************************ROUTINE 6: WRITING VOTES OF INDIVIDUAL CANDIDATE************
VOTEWRITE:


MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT







MOV A, CCODE
MOV B,#02h
MUL AB
MOV HBADD,A


CALL OUT ;SEND IT, A IS HOLDING D ADDRESS WHERE V HAV TO WRITE



MOV R0,#30h
MOV A,HBADD
ADD A,R0
MOV R0,A


MOV A,@R0
CALL OUT ;SEND IT

CALL STOP ;SEND STOP CONDITION
ACALL DELAY_STOP



INC R0

;ACALL EEPROM_WRITE 

 
MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT
		
		INC HBADD

               MOV A,HBADD ;GET BYTE ADDRESS

               CALL OUT ;SEND IT

               MOV A,@R0 ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION
ACALL DELAY_STOP




 
;INC R0
;MOV B,@R0
;INC DPTR
;ACALL EEPROM_WRITE

RET






;************** ROUTINE 7: READING VOTES OF EACH CANDIDATE INTO IRAM***************
VOTEREAD:   


MOV R3,#10h
MOV R0,#32h
MOV MEMORY,#02h


LABEL:


MOV     A,#WTCMD        ;LOAD WRITE COMMAND TO SEND ADDRESS

               CALL    OUTS            ;SEND IT

              MOV     A,MEMORY            ;GET LOW BYTE ADDRESS

              CALL    OUT             ;SEND IT

              CALL    CREAD           ;GET DATA BYTE

              MOV A,R1 
MOV @R0,A
INC R0
INC MEMORY 
DJNZ R3,LABEL









;MOV R3,#10h
;MOV R0,#32h
;MOV DPTR,#002h
;LABEL:ACALL EEPROM_READ
;MOV @R0,A
;INC R0
;INC DPTR
;DJNZ R3,LABEL
RET





;************** ROUTINE 8: INITIALIZING EEPROM LOCATIONS WHERE TOTAL COUNT HAS TO BE SAVED, BY ZERO******


MEMORYINIT:

MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT

               MOV A,#84H ;GET BYTE ADDRESS

               CALL OUT ;SEND IT

               MOV A,#00h ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION

ACALL DELAY_STOP


MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT

               MOV A,#85H ;GET BYTE ADDRESS

               CALL OUT ;SEND IT

               MOV A,#00h ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION
ACALL DELAY_STOP





RET







;************** ROUTINE 9: INITIALIZING EEPROM LOCATIONS WHERE INDIVIDUAL COUNT HAS TO BE SAVED, BY ZERO******



MEMINIT:

MOV R3,#10h

MOV R4,#02h


LABELM:




MOV A,#WTCMD ;LOAD WRITE COMMAND

               CALL OUTS ;SEND IT

               MOV A,R4 ;GET BYTE ADDRESS

               CALL OUT ;SEND IT


               MOV A,#00h ;GET DATA

               CALL OUT ;SEND IT

               CALL STOP ;SEND STOP CONDITION
ACALL DELAY_STOP


    

INC R4
DJNZ R3,LABELM

RET

















;***********************************************************************

;                EEPROM ROUTINES

;***********************************************************************







;***********************************************************************

; THIS ROUTINE SENDS OUT CONTENTS OF THE ACCUMULATOR

; to the EEPROM and includes START condition.  Refer to the data sheets

; for discussion of START and STOP conditions.

;***********************************************************************




OUTS:   MOV     R2,#8           ;LOOP COUNT -- EQUAL TO BIT COUNT

        SETB   SDA1            ;INSURE DATA IS HI               

        SETB    SCL1            ;INSURE CLOCK IS HI

        NOP                     ;NOTE 1

        NOP                     

        NOP

        CLR     SDA1            ;START CONDITION -- DATA = 0

        NOP                     ;NOTE 1

        NOP      

        NOP

        CLR     SCL1            ;CLOCK = 0

OTSLP:  RLC     A               ;SHIFT BIT

        JNC     BITLS

        SETB    SDA1            ;DATA = 1

        JMP     OTSL1           ;CONTINUE

BITLS:  CLR     SDA1            ;DATA = 0

OTSL1:  SETB    SCL1            ;CLOCK HI

        NOP                     ;NOTE 1

        NOP

        NOP

        

        CLR     SCL1            ;CLOCK LOW

        DJNZ    R2,OTSLP        ;DECREMENT COUNTER

        SETB    SDA1            ;TURN PIN INTO INPUT

        NOP                     ;NOTE 1

                             

        SETB    SCL1            ;CLOCK ACK

        NOP                     ;NOTE 1

        NOP

        NOP

      

        CLR     SCL1

        RET




;**********************************************************************

; THIS ROUTINE SENDS OUT CONTENTS OF ACCUMLATOR TO EEPROM

; without sending a START condition.

;**********************************************************************




OUT:    MOV     R2,#8           ;LOOP COUNT -- EQUAL TO BIT COUNT

OTLP:   RLC     A               ;SHIFT BIT

        JNC     BITL            

        SETB    SDA1            ;DATA = 1

        JMP     OTL1            ;CONTINUE

BITL:   CLR     SDA1            ;DATA = 0

OTL1:   SETB    SCL1            ;CLOCK HI

        NOP                     ;NOTE 1

        NOP

        NOP

     

        CLR     SCL1            ;CLOCK LOW

        DJNZ    R2,OTLP         ;DECREMENT COUNTER

        SETB    SDA1            ;TURN PIN INTO INPUT

        NOP                     ;NOTE 1

     

        SETB    SCL1            ;CLOCK ACK

        NOP                     ;NOTE 1

        NOP

        NOP

      

        CLR     SCL1

        RET







STOP:   CLR     SDA1            ;STOP CONDITION SET DATA LOW

        NOP                     ;NOTE 1

        NOP

        NOP

      

        SETB    SCL1            ;SET CLOCK HI

        NOP                     ;NOTE 1

        NOP

        NOP

      

        SETB    SDA1            ;SET DATA HIGH

        RET

;*******************************************************************

; THIS ROUTINE READS A BYTE OF DATA FROM EEPROM

; From EEPROM current address pointer.

; Returns the data byte in R1

;*******************************************************************

CREAD:  MOV     A,#RDCMD        ;LOAD READ COMMAND

        CALL    OUTS            ;SEND IT

        CALL    IN              ;READ DATA

        MOV     R1,A            ;STORE DATA

        CALL    STOP            ;SEND STOP CONDITION

        RET




;**********************************************************************

; THIS ROUTINE READS IN A BYTE FROM THE EEPROM

; and stores it in the accumulator

;**********************************************************************




IN:     MOV     R2,#8           ;LOOP COUNT

        SETB    SDA1            ;SET DATA BIT HIGH FOR INPUT

INLP:   CLR     SCL1            ;CLOCK LOW

        NOP                     ;NOTE 1

        NOP

        NOP

        NOP

     

        SETB    SCL1            ;CLOCK HIGH

        CLR     C               ;CLEAR CARRY

        JNB     SDA1,INL1       ;JUMP IF DATA = 0

        CPL     C               ;SET CARRY IF DATA = 1

INL1:   RLC     A               ;ROTATE DATA INTO ACCUMULATOR

        DJNZ    R2,INLP         ;DECREMENT COUNTER

        CLR     SCL1            ;CLOCK LOW

        RET




;*********************************************************************

; This routine test for WRITE DONE condition 

; by testing for an ACK.

; This routine can be run as soon as a STOP condition

; has been generated after the last data byte has been sent

; to the EEPROM. The routine loops until an ACK is received from 

; the EEPROM. No ACK will be received until the EEPROM is done with

; the write operation.

;*********************************************************************

ACKTST: MOV     A,#WTCMD        ;LOAD WRITE COMMAND TO SEND ADDRESS

        MOV     R2,#8           ;LOOP COUNT -- EQUAL TO BIT COUNT

        CLR     SDA1            ;START CONDITION -- DATA = 0

        NOP                     ;NOTE 1

        NOP

        NOP

           

        CLR     SCL1            ;CLOCK = 0

AKTLP:  RLC     A               ;SHIFT BIT

        JNC     AKTLS

        SETB    SDA1            ;DATA = 1

        JMP     AKTL1           ;CONTINUE

AKTLS:  CLR     SDA1            ;DATA = 0

AKTL1:  SETB    SCL1            ;CLOCK HI

        NOP                     ;NOTE 1

        NOP

        NOP

      

        CLR     SCL1            ;CLOCK LOW

        DJNZ    R2,AKTLP        ;DECREMENT COUNTER

        SETB    SDA1            ;TURN PIN INTO INPUT

        NOP                     ;NOTE 1

      

        SETB    SCL1            ;CLOCK ACK

        NOP                     ;NOTE 1

        NOP

        NOP

       

        JNB     SDA1,EXIT       ;EXIT IF ACK (WRITE DONE)

        JMP     ACKTST          ;START OVER

EXIT:   CLR     SCL1            ;CLOCK LOW

        CLR     SDA1            ;DATA LOW

        NOP                     ;NOTE 1

        NOP

        NOP

      

        SETB    SCL1            ;CLOCK HIGH

        NOP

        NOP

        SETB    SDA1            ;STOP CONDITION

        RET

;*********************************************************************


































;********************** EEPROM ROUTINES COMMON TO ALL ***********************

EEPROM_READ:         ;read from eeprom
ACALL I2C_START
ACALL EEPROM_WRITE_ADDR
ACALL ACK
MOV  A,DPH
ACALL I2C_WRITE
ACALL ACK
MOV  A,DPL
ACALL I2C_WRITE
ACALL ACK
ACALL I2C_START
ACALL EEPROM_READ_ADDR
ACALL ACK
ACALL I2C_READ
ACALL NO_ACK
ACALL I2C_STOP
RET








EEPROM_WRITE:        ;write in to eeprom
ACALL I2C_START
ACALL EEPROM_WRITE_ADDR
ACALL ACK
MOV  A,DPH
ACALL I2C_WRITE
ACALL ACK
MOV  A,DPL
ACALL I2C_WRITE
ACALL ACK
MOV  A,B
ACALL I2C_WRITE
ACALL ACK
ACALL I2C_STOP
ACALL DELAY_STOP
RET




I2C_READ:            ;reading 8 bits from i2c device
MOV R7,#8
GFD:
;SETB SDA
;SETB SCL 
;MOV C,SDA 
RLC A
;CLR SCL
DJNZ R7,GFD
RET

I2C_WRITE:           ;writing 8 bits in to i2c device
MOV R7,#8
WRITING:
RLC A
;MOV SDA,C
ACALL CLOCK
DJNZ R7,WRITING
RET

I2C_START:           ;start of i2c routine
;SETB SCL
;SETB SDA 
;CLR SDA
;CLR SCL
RET

I2C_STOP:            ;end of i2c routine
;SETB SCL
;CLR SDA
;SETB SDA 
;CLR SCL
RET

CLOCK:               ;synchronizing clock 
;SETB SCL
NOP
NOP
;CLR SCL
RET

ACK:                 ;acknowledge from transmitter or receiver
;CLR SDA
;SETB SCL
;CLR SCL
RET

NO_ACK:              ;no acknowledge from transmitter or receiver
;SETB SDA
;SETB SCL
;CLR SCL
RET

EEPROM_READ_ADDR:     ;A2,A1,A0 are zero
MOV A,#10100001B
ACALL I2C_WRITE
RET

EEPROM_WRITE_ADDR:    ;A2,A1,A0 are zero
MOV A,#10100000B
ACALL I2C_WRITE
RET


DELAY_STOP:           ;terminating write process
MOV TMOD,#00000001B
MOV TH0,#50H 
MOV TL0,#00H
SETB TR0
SAC:
JNB TF0,SAC
CLR TR0
CLR TF0
RET

;******************EEPROM ROUTINES COMMON TO ALL, END HERE********************

END			  